module Main where

import Language
import Parser
import TypeChecker
import AuxTypes
import Interpreter
import Matrix

main =
   do s <- getContents
      let e = parse (lexer s)
--    print e
      case run (typecheck e) of
         Ok ce     -> putStr ("Type: " ++ show (typ ce) ++ "\n") >>
                      putStr ("Bits: " ++ show (exprbits ce) ++ "\n") >>
                      let s0 = d 0
                      in  print (ev ce s0)
         Error msg -> putStr ("Type error: " ++ msg ++ "\n")
